'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormattedHTMLMessage = exports.FormattedMessage = exports.FormattedPlural = exports.FormattedNumber = exports.FormattedRelative = exports.FormattedTime = exports.FormattedDate = exports.IntlProvider = exports.injectIntl = exports.intlShape = exports.addLocaleData = undefined;

var _types = require('./types');

Object.defineProperty(exports, 'intlShape', {
  enumerable: true,
  get: function get() {
    return _types.intlShape;
  }
});

var _inject = require('./inject');

Object.defineProperty(exports, 'injectIntl', {
  enumerable: true,
  get: function get() {
    return _inject.default;
  }
});

var _intl = require('./components/intl');

Object.defineProperty(exports, 'IntlProvider', {
  enumerable: true,
  get: function get() {
    return _intl.default;
  }
});

var _date = require('./components/date');

Object.defineProperty(exports, 'FormattedDate', {
  enumerable: true,
  get: function get() {
    return _date.default;
  }
});

var _time = require('./components/time');

Object.defineProperty(exports, 'FormattedTime', {
  enumerable: true,
  get: function get() {
    return _time.default;
  }
});

var _relative = require('./components/relative');

Object.defineProperty(exports, 'FormattedRelative', {
  enumerable: true,
  get: function get() {
    return _relative.default;
  }
});

var _number = require('./components/number');

Object.defineProperty(exports, 'FormattedNumber', {
  enumerable: true,
  get: function get() {
    return _number.default;
  }
});

var _plural = require('./components/plural');

Object.defineProperty(exports, 'FormattedPlural', {
  enumerable: true,
  get: function get() {
    return _plural.default;
  }
});

var _message = require('./components/message');

Object.defineProperty(exports, 'FormattedMessage', {
  enumerable: true,
  get: function get() {
    return _message.default;
  }
});

var _htmlMessage = require('./components/html-message');

Object.defineProperty(exports, 'FormattedHTMLMessage', {
  enumerable: true,
  get: function get() {
    return _htmlMessage.default;
  }
});
exports.defineMessages = defineMessages;

var _en = require('./en');

var _en2 = _interopRequireDefault(_en);

var _localeDataRegistry = require('./locale-data-registry');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Copyright 2015, Yahoo Inc.
 * Copyrights licensed under the New BSD License.
 * See the accompanying LICENSE file for terms.
 */

(0, _localeDataRegistry.addLocaleData)(_en2.default);

exports.addLocaleData = _localeDataRegistry.addLocaleData;
function defineMessages(messageDescriptors) {
  // This simply returns what's passed-in because it's meant to be a hook for
  // babel-plugin-react-intl.
  return messageDescriptors;
}